//============================================================================
// 635 Linux Demonstration Code.
// test635,c: Ultra-simple 635 command-line communications example
// Copyright 2005, Crystalfontz America, Inc. Written by Brent A. Crosby
// www.crystalfontz.com, brent@crystalfontz.com
//============================================================================
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "typedefs.h"
#include "serial.h"
#include "cf_packet.h"
#include "show_packet.h"

//============================================================================
int main(int argc, char* argv[])
{
    if(argc <= 2)
    {
        printf("Usage:\n");
        printf("%s PORT COMMAND OPTIONS\n",argv[0]);
        return(1);
    }
    
    int
    cleardisplay=0;
    if((!strcmp(argv[2],"clear"))) cleardisplay=1;
    
    int
    line1=0;
    if((!strcmp(argv[2],"line1"))&&(argc == 4)) line1=1;
    if((!strcmp(argv[2],"line1"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line1 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line2=0;
    if((!strcmp(argv[2],"line2"))&&(argc == 4)) line2=1;
    if((!strcmp(argv[2],"line2"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line2 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line3=0;
    if((!strcmp(argv[2],"line3"))&&(argc == 4)) line3=1;
    if((!strcmp(argv[2],"line3"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line3 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line4=0;
    if((!strcmp(argv[2],"line4"))&&(argc == 4)) line4=1;
    if((!strcmp(argv[2],"line4"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line4 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    led1=0;
    if((!strcmp(argv[2],"led1"))&&(argc == 4)) led1=1;
    if((!strcmp(argv[2],"led1"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT led1 [off|green|red|amber]\n",argv[0]);
        return(1);
    }
    
    int
    led2=0;
    if((!strcmp(argv[2],"led2"))&&(argc == 4)) led2=1;
    if((!strcmp(argv[2],"led2"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT led2 [off|green|red|amber]\n",argv[0]);
        return(1);
    }
    
    int
    led3=0;
    if((!strcmp(argv[2],"led3"))&&(argc == 4)) led3=1;
    if((!strcmp(argv[2],"led3"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT led3 [off|green|red|amber]\n",argv[0]);
        return(1);
    }
    
    int
    led4=0;
    if((!strcmp(argv[2],"led4"))&&(argc == 4)) led4=1;
    if((!strcmp(argv[2],"led4"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT led4 [off|green|red|amber]\n",argv[0]);
        return(1);
    }
    
    int
    backlite=0;
    if((!strcmp(argv[2],"backlite"))&&(argc == 4)) backlite=1;
    if((!strcmp(argv[2],"backlite"))&&(argc == 5)) backlite=1;
    if((!strcmp(argv[2],"backlite"))&&(argc == 3))
    {
        printf("Missing Command Options:\n");
        printf("%s PORT backlite [off|default|low|med|high|max] [NULL|key]\n",argv[0]);
        return(1);
    }
    
    //    int
    //    line1m=0;
    //    if((!strcmp(argv[2],"line1m"))&&(argc == 4)) line1m=1;
    //    if((!strcmp(argv[2],"line1m"))&&(argc == 3))
    //    {
    //        printf("Missing Command Option:\n");
    //        printf("%s PORT line1m MESSAGE\n",argv[0]);
    //        return(1);
    //    }

    int
    linesc1=0;
    if((!strcmp(argv[2],"linesc1"))&&(argc == 4)) linesc1=1;
    if((!strcmp(argv[2],"linesc1"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT linesc1 MESSAGE\n",argv[0]);
        return(1);
    }
	
    int
    linesc2=0;
    if((!strcmp(argv[2],"linesc2"))&&(argc == 4)) linesc2=1;
    if((!strcmp(argv[2],"linesc2"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT linesc2 MESSAGE\n",argv[0]);
        return(1);
    }

    int
    line1c1=0;
    if((!strcmp(argv[2],"line1c1"))&&(argc == 4)) line1c1=1;
    if((!strcmp(argv[2],"line1c1"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line1c1 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line2c1=0;
    if((!strcmp(argv[2],"line2c1"))&&(argc == 4)) line2c1=1;
    if((!strcmp(argv[2],"line2c1"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line2c1 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line3c1=0;
    if((!strcmp(argv[2],"line3c1"))&&(argc == 4)) line3c1=1;
    if((!strcmp(argv[2],"line3c1"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line3c1 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line4c1=0;
    if((!strcmp(argv[2],"line4c1"))&&(argc == 4)) line4c1=1;
    if((!strcmp(argv[2],"line4c1"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line4c1 MESSAGE\n",argv[0]);
        return(1);
    }

    int
    line1c2=0;
    if((!strcmp(argv[2],"line1c2"))&&(argc == 4)) line1c2=1;
    if((!strcmp(argv[2],"line1c2"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line1c2 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line2c2=0;
    if((!strcmp(argv[2],"line2c2"))&&(argc == 4)) line2c2=1;
    if((!strcmp(argv[2],"line2c2"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line2c2 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line3c2=0;
    if((!strcmp(argv[2],"line3c2"))&&(argc == 4)) line3c2=1;
    if((!strcmp(argv[2],"line3c2"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line3c2 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line4c2=0;
    if((!strcmp(argv[2],"line4c2"))&&(argc == 4)) line4c2=1;
    if((!strcmp(argv[2],"line4c2"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line4c2 MESSAGE\n",argv[0]);
        return(1);
    }

    int
    line1c3=0;
    if((!strcmp(argv[2],"line1c3"))&&(argc == 4)) line1c3=1;
    if((!strcmp(argv[2],"line1c3"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line1c3 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line2c3=0;
    if((!strcmp(argv[2],"line2c3"))&&(argc == 4)) line2c3=1;
    if((!strcmp(argv[2],"line2c3"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line2c3 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line3c3=0;
    if((!strcmp(argv[2],"line3c3"))&&(argc == 4)) line3c3=1;
    if((!strcmp(argv[2],"line3c3"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line3c3 MESSAGE\n",argv[0]);
        return(1);
    }
    
    int
    line4c3=0;
    if((!strcmp(argv[2],"line4c3"))&&(argc == 4)) line4c3=1;
    if((!strcmp(argv[2],"line4c3"))&&(argc == 3))
    {
        printf("Missing Command Option:\n");
        printf("%s PORT line4c3 MESSAGE\n",argv[0]);
        return(1);
    }

    int
    baud;
    baud=115200;
    
    int
    k;
    
    if(Serial_Init(argv[1],baud))
    {
        //      printf("Could not open port \"%s\"\n",argv[1],baud);
        return(1);
    }
    else
        while(BytesAvail())
            GetByte();
    
    //Outgoing command packets. Either clear the screen
    //or send our line information
    //**********************************************
    if(cleardisplay)
    {
        outgoing_response.command = 6;
        outgoing_response.data_length = 0;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 6;
        outgoing_response.data_length = 0;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if(line1)
    {
        outgoing_response.command = 31;
        outgoing_response.data[0]=0; //col
        outgoing_response.data[1]=0; //row
        memcpy(&outgoing_response.data[2],argv[3],20);
        outgoing_response.data_length = 22;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if(line2)
    {
        outgoing_response.command = 31;
        outgoing_response.data[0]=0; //col
        outgoing_response.data[1]=1; //row
        memcpy(&outgoing_response.data[2],argv[3],20);
        outgoing_response.data_length = 22;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if(line3)
    {
        outgoing_response.command = 31;
        outgoing_response.data[0]=0; //col
        outgoing_response.data[1]=2; //row
        memcpy(&outgoing_response.data[2],argv[3],20);
        outgoing_response.data_length = 22;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if(line4)
    {
        outgoing_response.command = 31;
        outgoing_response.data[0]=0; //col
        outgoing_response.data[1]=3; //row
        memcpy(&outgoing_response.data[2],argv[3],20);
        outgoing_response.data_length = 22;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led4)&&(!strcmp(argv[3],"off")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000101;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000110;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led4)&&(!strcmp(argv[3],"green")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000101;
        outgoing_response.data[1]=0b01100100;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000110;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led4)&&(!strcmp(argv[3],"red")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000101;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000110;
        outgoing_response.data[1]=0b01100100;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led4)&&(!strcmp(argv[3],"amber")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000101;
        outgoing_response.data[1]=0b00110010;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000110;
        outgoing_response.data[1]=0b00110010;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led3)&&(!strcmp(argv[3],"off")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000111;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001000;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led3)&&(!strcmp(argv[3],"green")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000111;
        outgoing_response.data[1]=0b01100100;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001000;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led3)&&(!strcmp(argv[3],"red")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000111;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001000;
        outgoing_response.data[1]=0b01100100;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led3)&&(!strcmp(argv[3],"amber")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00000111;
        outgoing_response.data[1]=0b00110010;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001000;
        outgoing_response.data[1]=0b00110010;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led2)&&(!strcmp(argv[3],"off")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001001;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001010;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led2)&&(!strcmp(argv[3],"green")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001001;
        outgoing_response.data[1]=0b01100100;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001010;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led2)&&(!strcmp(argv[3],"red")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001001;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001010;
        outgoing_response.data[1]=0b01100100;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led2)&&(!strcmp(argv[3],"amber")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001001;
        outgoing_response.data[1]=0b00110010;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001010;
        outgoing_response.data[1]=0b00110010;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led1)&&(!strcmp(argv[3],"off")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001011;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001100;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led1)&&(!strcmp(argv[3],"green")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001011;
        outgoing_response.data[1]=0b01100100;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001100;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led1)&&(!strcmp(argv[3],"red")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001011;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001100;
        outgoing_response.data[1]=0b01100100;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((led1)&&(!strcmp(argv[3],"amber")))
    {
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001011;
        outgoing_response.data[1]=0b00110010;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 34;
        outgoing_response.data[0]=0b00001100;
        outgoing_response.data[1]=0b00110010;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((backlite)&&(!strcmp(argv[3],"off")))
    {
        outgoing_response.command = 14;
        outgoing_response.data[0]=0b00000000;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((backlite)&&(!strcmp(argv[3],"default")))
    {
        outgoing_response.command = 14;
        outgoing_response.data[0]=0b00000001;
        outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((backlite)&&(!strcmp(argv[3],"low")))
    {
        outgoing_response.command = 14;
        outgoing_response.data[0]=0b00011001;
        if(argc == 5) outgoing_response.data[1]=0b00011001;
        if(argc == 4) outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((backlite)&&(!strcmp(argv[3],"med")))
    {
        outgoing_response.command = 14;
        outgoing_response.data[0]=0b00110010;
        if(argc == 5) outgoing_response.data[1]=0b00110010;
        if(argc == 4) outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((backlite)&&(!strcmp(argv[3],"high")))
    {
        outgoing_response.command = 14;
        outgoing_response.data[0]=0b01001011;
        if(argc == 5) outgoing_response.data[1]=0b01001011;
        if(argc == 4) outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if((backlite)&&(!strcmp(argv[3],"max")))
    {
        outgoing_response.command = 14;
        outgoing_response.data[0]=0b01100100;
        if(argc == 5) outgoing_response.data[1]=0b01100100;
        if(argc == 4) outgoing_response.data[1]=0b00000000;
        outgoing_response.data_length = 2;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    //    if(line1m)
    //    {
    //        outgoing_response.command = 38; // Custom Fonts Group
    //        outgoing_response.data[0]=0b00000000; // Load Font
    //        outgoing_response.data[1]=0b00000001; // Slot 1
    //        outgoing_response.data[2]=0b00000000; // Option Flags (None)
    //        outgoing_response.data[3]=0b01011100; // slash
    //        outgoing_response.data[4]=0b01101101; //  m
    //        outgoing_response.data[5]=0b01101111; //  o
    //        outgoing_response.data[6]=0b01101110; //  n
    //        outgoing_response.data[7]=0b01100001; //  a
    //        outgoing_response.data[8]=0b01100011; //  c
    //        outgoing_response.data[9]=0b01101111; //  o
    //        outgoing_response.data[10]=0b00111001; // 9
    //        outgoing_response.data[11]=0b00101110; // .
    //        outgoing_response.data[12]=0b01100011; // c
    //        outgoing_response.data[13]=0b01100110; // f
    //        outgoing_response.data[14]=0b01100110; // f
    //        outgoing_response.data_length = 15;
    //        send_packet();
    //        for(k=0;k<=10000;k++)
    //            check_for_packet();
    //        outgoing_response.command = 38;
    //        outgoing_response.data[0]=0b00000001; // Print Font
    //        outgoing_response.data[1]=0b00000001; // Slot 1
    //        outgoing_response.data[2]=0b00000000; // Place by character
    //        outgoing_response.data[3]=0b00000000; // col 0
    //        outgoing_response.data[4]=0b00000000; // row 0
    //        memcpy(&outgoing_response.data[5],argv[3],40);
    //        outgoing_response.data_length = 45;
    //        send_packet();
    //        for(k=0;k<=10000;k++)
    //            check_for_packet();
    //        Uninit_Serial();
    //    }
    
    if(linesc1)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000001; // Slot 1
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01101101; //  m
        outgoing_response.data[5]=0b01101111; //  o
        outgoing_response.data[6]=0b01101110; //  n
        outgoing_response.data[7]=0b01100001; //  a
        outgoing_response.data[8]=0b01100011; //  c
        outgoing_response.data[9]=0b01101111; //  o
        outgoing_response.data[10]=0b00111001; // 9
        outgoing_response.data[11]=0b00101110; // .
        outgoing_response.data[12]=0b01100011; // c
        outgoing_response.data[13]=0b01100110; // f
        outgoing_response.data[14]=0b01100110; // f
        outgoing_response.data_length = 15;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000001; // Slot 1
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b00000010; // x 2
        outgoing_response.data[4]=0b00111010; // y 58
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if(linesc2)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000011; // Slot 3
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100010; //  b
	outgoing_response.data[5]=0b01101001; //  i
        outgoing_response.data[6]=0b01100111; //  g
	outgoing_response.data[7]=0b00101110; // .
        outgoing_response.data[8]=0b01100011; // c
        outgoing_response.data[9]=0b01100110; // f
        outgoing_response.data[10]=0b01100110; // f
        outgoing_response.data_length = 11;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000011; // Slot 3
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b00000011; // x 3
        outgoing_response.data[4]=0b00010000; // y 16
	memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }

    if(line1c1)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b00000011; // x 3
        outgoing_response.data[4]=0b00000010; // y 2
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    if(line2c1)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b00000011; // x 3
        outgoing_response.data[4]=0b00010000; // y 16
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    if(line3c1)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b00000011; // x 3
        outgoing_response.data[4]=0b00011110; // y 30
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    if(line4c1)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b00000011; // x 3
        outgoing_response.data[4]=0b00101100; // y 44
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if(line1c2)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b01010100; // x 84
        outgoing_response.data[4]=0b00000010; // y 2
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    if(line2c2)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b01010100; // x 84
        outgoing_response.data[4]=0b00010000; // y 16
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    if(line3c2)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b01010100; // x 84
        outgoing_response.data[4]=0b00011110; // y 30
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    if(line4c2)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b01010100; // x 84
        outgoing_response.data[4]=0b00101100; // y 44
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    if(line1c3)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b10100101; // x 165
        outgoing_response.data[4]=0b00000010; // y 2
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    if(line2c3)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b10100101; // x 165
        outgoing_response.data[4]=0b00010000; // y 16
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    if(line3c3)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b10100101; // x 165
        outgoing_response.data[4]=0b00011110; // y 30
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    if(line4c3)
    {
        outgoing_response.command = 38; // Custom Fonts Group
        outgoing_response.data[0]=0b00000000; // Load Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000000; // Option Flags (None)
        outgoing_response.data[3]=0b01011100; // slash
        outgoing_response.data[4]=0b01100011; //  c
        outgoing_response.data[5]=0b01101000; //  h
        outgoing_response.data[6]=0b01101001; //  i
        outgoing_response.data[7]=0b01100011; //  c
        outgoing_response.data[8]=0b01100001; //  a
        outgoing_response.data[9]=0b01100111; //  g
        outgoing_response.data[10]=0b01101111; // o
        outgoing_response.data[11]=0b00110001; // 1
        outgoing_response.data[12]=0b00110010; // 2
        outgoing_response.data[13]=0b00101110; // .
        outgoing_response.data[14]=0b01100011; // c
        outgoing_response.data[15]=0b01100110; // f
        outgoing_response.data[16]=0b01100110; // f
        outgoing_response.data_length = 17;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        outgoing_response.command = 38;
        outgoing_response.data[0]=0b00000001; // Print Font
        outgoing_response.data[1]=0b00000010; // Slot 2
        outgoing_response.data[2]=0b00000001; // Place by bit
        outgoing_response.data[3]=0b10100101; // x 165
        outgoing_response.data[4]=0b00101100; // y 44
        memcpy(&outgoing_response.data[5],argv[3],40);
        outgoing_response.data_length = 45;
        send_packet();
        for(k=0;k<=10000;k++)
            check_for_packet();
        Uninit_Serial();
    }
    
    return 0;
}
